Status: Resolved Priority: Should have
Author: Bastian Waidelich Category: Error

Created: 2012-07-31 Assigned To: Bastian Waidelich
Updated: 2013-01-10 Due date:

PHP Version:

Has patch: No

Complexity:

Subject: Custom Error Renderers

Description

It should be possible to render certain exceptions (based on exception class name and/or status code) with a custom (fluid) template.

This could also replace the currently used "NotFoundController-mechanism".

Subtasks:

Feature # 44218: Custom Error Renderers

New

Related issues:
related to TYPOS3.Flow - Bug # 37001: Catch Exception from inactivity Timeout
related to Base Distribution - Story # 40310: As any User, if no site exists ...

related to TYPOS3.Flow - Feature # 40857: When template is automatically retri...

related to TYPOS3.Flow - Bug # 40888: Add ViewNotFoundException

duplicated by Base Distribution - Task # 40723: Implement configurable except...

Resolved 2012-05-09
Postponed

Resolved 2012-09-12
Resolved 2012-09-13
Resolved

Associated revisions

Revision 20e41f38 - 2012-09-11 11:10 - Bastian Waidelich
["[FEATURE] Custom Error Renderers

This extends the exception handlers so that they can render arbitrary
templates based on the status code and/or class name of the thrown
exception.

The template to be used and variables that should be passed to the
template are configured in so called "renderingGroups" in the options

of the exception handler.

This is a breaking change because it deprecates the provided
NotFoundController & NotFoundView.

This patch also contains the related documentation, including general
information about FLOWS3's error handling.

Also included in this patch is an update to the YAML schema definitions.

Furthermore, removed all hints on "FLOW3" from the production exception
handler.

Change-Id: 111c34dece6a880027ac199319edf5f62221a01e9

Resolves: #39423
Releases: 1.2
Revision 9b28224c - 2012-09-11 17:00 - Robert Lemke

[TASK] Custom error page: higher priority for class matches

All custom error rendering options should be evaluated for
matches of the exception class name before trying to match
against status code because the latter are often used as
fallback options (for example, 404 for anything not found).

The TYPO3.TYPO3 package wouldn't be able to display a specific
"Missing Homepage" error message without this patch because
FLOWS's 404 handling would kick in before.

Change-Id: 175c7caabff68d1b30be93e7d5f85f580312f3e83
Related: #39423

Releases: 1.2

Revision ec4d4225 - 2012-10-17 11:19 - Robert Lemke
[BUGFIX] Fix path to database error template

The Settings.yaml contained an outdated path for the

Fluid template which is supposed to display database

errors.

The message of the fatal error caused by this bug contained:

"Template file "resource://TYPO3.Flow/Private/Error/Default_Template.html"

could not be loaded'

Change-Id: 17454989218b9f81457d3cf15324ac10b35d67ac3

Related: #39423

Releases: 1.2

Revision fcfbc329 - 2013-04-23 09:50 - Adrian Foder

[TASK] Complete documentation for Error Rendering Groups

This adds a section about how to configure and use the custom error

views resp. rendering groups.

Releases: master, 2.0

Related: #39423

Change-Id: 1212bac2a5ab6760aa5230403c8c46e06d5676f2a

Revision 29b87b09 - 2013-04-30 17:26 - Adrian Foéder

[TASK] Complete documentation for Error Rendering Groups

This adds a section about how to configure and use the custom error

views resp. rendering groups.
Releases: master, 2.0
Related: #39423
Change-Id: 1212bac2a5ab6760aa5230403c8c46e06d5676f2a

History

#1 - 2012-07-31 17:42 - Bastian Waidelich

Maybe we can extend the existing exception handler and/or use signal/slots to trigger some custom code if a certain exception is thrown..

#2 - 2012-09-07 09:44 - Bastian Waidelich

- Subject changed from Custom Error Workflows to Custom Error Renderers
- Category set to Error

- Status changed from New to Accepted

- Assigned To set to Bastian Waidelich

- Target version set to 2.0 beta 1

#3 - 2012-09-07 17:28 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14439

#4 - 2012-09-09 16:55 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14439

#5 - 2012-09-09 16:58 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/14439

#6 - 2012-09-11 11:11 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14439

#7 - 2012-09-11 14:35 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:20e41f38b36482eb3cd861463885e1a032111be4.
